<template>
    <div>
        <div class="row col">
            <h1>Users</h1>
        </div>

        <div class="row col">
            <form>
                <div class="form-row">
                    <div class="col-8">
                        <input v-model="login" placeholder="Login" type="text" class="form-control">
                    </div>
                    <div class="col-4">
                        <button @click="createUser()" :disabled="login.length === 0 || isLoading" type="button"
                                class="btn btn-primary">Create
                        </button>
                    </div>
                </div>
            </form>
        </div>

        <div v-if="isLoading" class="row col">
            <p>Loading...</p>
        </div>

        <div v-else-if="hasError" class="row col">
            <div class="alert alert-danger" role="alert">
                {{ error }}
            </div>
        </div>

        <div v-else-if="!hasUsers" class="row col">
            No users!
        </div>

        <div v-else class="row col">
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Login</th>
                    <th scope="col">Created</th>
                    <th scope="col">Roles</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="(user, index) in users">
                    <th scope="row">{{ index + 1 }}</th>
                    <td><input v-model="user.login"></td>
                    <td>{{ user.created }}</td>
                    <td>
                        <select v-model="user.roles[0]">
                            <option v-for="role in roles" v-bind:value="role.value">
                                {{ role.text }}
                            </option>
                        </select>
                    </td>
                    <td>
                        <button @click="editUser(user)" type="button" class="btn btn-sm btn-success">Save</button>
                    </td>
                    <td>
                        <button @click="deleteUser(user)" type="button" class="btn btn-sm btn-danger">Delete</button>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<script>
    import ErrorMessage from '../components/ErrorMessage';

    export default {
        name: 'users',
        components: {
            ErrorMessage,
        },
        data() {
            return {
                login: '',
                roles: [
                    {text: 'USER', value: 'ROLE_USER'},
                    {text: 'ADMINISTRATOR', value: 'ROLE_ADMIN'},
                ],
            };
        },
        created() {
            this.$store.dispatch('user/fetchUsers');
        },
        computed: {
            isLoading() {
                return this.$store.getters['user/isLoading'];
            },
            hasError() {
                return this.$store.getters['user/hasError'];
            },
            error() {
                return this.$store.getters['user/error'];
            },
            hasUsers() {
                return this.$store.getters['user/hasUsers'];
            },
            users() {
                return this.$store.getters['user/users'];
            },
        },
        methods: {
            createUser() {
                this.$store.dispatch('user/createUser', this.$data.login)
                    .then(() => this.$data.login = '')
            },
            editUser(user) {
                this.$store.dispatch('user/editUser', user)
                    .then(() => this.$store.dispatch('user/fetchUsers'))
            },
            deleteUser(user) {
                this.$store.dispatch('user/deleteUser', user.id)
                    .then(() => this.$store.dispatch('user/fetchUsers'))
            },
        },
    }
</script>